                //   %%%%%%融资约束 企业异质性与减税降费的政策效果%%%%%%   以下是基准的参数设定 可以根据文章提供的参数 划出相关的脉冲反应图

var  ct, cgt, cmt, lt, lgt, lmt, imgt, immt, piet, piegt, piemt, tot, wgt, wmt, rkgt, rkmt, rnt, ygt, ymt, kgt, kmt, ngt, nmt, qkmt, tremt, tregt, govgt, gct;  // kft,ift ; 
var  xgt,   pgt, pmt, xwgt, xwmt, riskgt, riskmt,  imt, yt,namt; 
var  tech_gt, tech_mt,tax_sbt,igt,iggt,igmt,qkgt,jjgt; 
varexo   tech_gs, tech_ms, tregs,  trems, govgs, gcts,tax_sbs; 
parameters   ug,  um,  ag,  am, veig, veim,  wog, wom, beta, hab, vlabor, xi, lgl, eta, afa1, ru1, afa2, ru2, delta, faig, faim; 
parameters    phig,  phim, elas,  pricead, thinta, kapg, kapm,  rn ; 
parameters   kgng, ugg, rkg, kgyg,  kmnm, ugm, rkm, kmym, ygym, igyg, imym, ggyg, cgyg  ; 

parameters gmym, cmym, eq18_treg,  eq28_trem, eq5_c, eq5_ct, eq5_ct1, eq6_rn, eq18_x, eq28_x, rr, rpie, rpieg, rpiem, ryg, rym, rryy, rz; 
parameters  techg_ar,  techm_ar,  treg_ar,  trem_ar,  gg_ar,  gm_ar  ; 
parameters eq18_net eq28_net eq18_rkg   eq28_rkm  ymy ygy ogm ru4 eqafa1   para_gy  sbjflg sbjflm; 
para_gy=0;   //如果国有企业减税取1

ygym=2/3;    //国有企业与非国有产出之比

ogm=0.0946;   //   公共资本的份额   

ug=0.001;         // 国有融资溢价弹性
um=0.0818;       // 非国有融资溢价弹性



ag=0.6;              //国有部门生产函数中资本的份额
am=0.32;              //非国有部门生产函数中资本的份额

veig=0.2;           //国有部门资本实际回报率的替代弹性       
veim=0.2;           //民营部门资产价格变动对投资的反应  

wog=2;               //国有企业杠杆率
wom=2;               //民营经济杠杆率

//居民效用函数
beta=0.985;
hab=0.0;            // habit formation 
vlabor=0.2;        // 劳动替代弹性
xi=1;              // 劳动的系数

lgl=0.3;           //提供给国有企业的劳动力
eta=0.5;            //  劳动的替代弹性 

//各种复合
afa1=0.01;              //消费品中的国有企业商品的比重
ru1=1;                 //国有和民营消费品的替代弹性

afa2=0.7;              // 国有企业投资品中国有投资品的比重 
ru2=1;                 //  国有和民营投资品的替代弹性

// 生产部门
delta=0.025;          // 资本的折旧率

faig=0.25;          //国有部门资产价格变动对投资的反应   
faim=0.25;          //民营部门资产价格变动对投资的反应  

phig=0.91;          // 国有企业生存概率
phim=0.91;         // 民营企业生存概率

elas=6;           //  retail部门的替代弹性
pricead=elas/(elas-1);

thinta=0.75;
kapg=(1-thinta)*(1-beta*thinta)/thinta;
kapm=kapg;



sbjflg=0.2;   //
sbjflm=0.2;   //
ru4=-0.01;

// 均衡值的求解                           
rn=1/beta;
                                                     
// 国有经济杠杆率相关变量
kgng=wog;
                                               
ugg=0.00;                                    // 可能有影响 
rkg=rn*(kgng)^ugg;   // case1


kgyg=ag/(pricead*(rkg-1+delta));


//民营经济杠杆率相关变量
kmnm=wom;
ugm=0.00;
rkm=rn*(kmnm)^ugm;   // case1         //     注意啊！
kmym=am/(pricead*(rkm-1+delta)) ;

//  产出相对比例的求解
igyg=2*delta*(kgyg+(kmym/ygym))*afa2;
imym=2*delta*(kgyg*ygym+kmym)*(1-afa2);



ggyg=0.4;
gmym=ggyg*ygym;

//18
 eq18_treg=1*kgng*veig/ag;
 
//28
  eq28_trem=1*kmnm*veim/am;

cgyg=1-igyg-0.10;
cmym=1-imym-0.10;
 
eqafa1=1/(1+(cmym/cgyg)*3/2);

//5
eq5_c=hab/((1-beta*hab)*(1-hab));
eq5_ct=(1+beta*hab*hab)/((1-beta*hab)*(1-hab));
eq5_ct1=beta*eq5_c;

//6
eq6_rn=(1-beta)*(rn/(rn-1));

eq18_x=(1-wog)*phig;
eq28_x=(1-wom)*phim;

eq18_rkg= (rkg-1)/(1+(rkg-1));
eq28_rkm= (rkm-1)/(1+(rkm-1));

//货币政策
rr=0.9;
rpie=0.15;
rpieg=0.0;
rpiem=0;
ryg=0.0;
rym=0.0;
rryy=0;
rz=0.00;


//shock

techg_ar=0.8;
techm_ar=0.8;
treg_ar=0.8;
trem_ar=0.8;
gg_ar=0.80;
gm_ar=0.8;


eq18_net=(ug*(wog-1)+1)*phig;
eq28_net=(um*(wom-1)+1)*phim;


// 产出加总方程
 ymy=1/(1+ygym) ;
 ygy=ygym/(1+ygym); 
 
// sii=4.75;
//  eq14b=sii*(1+0.99);
 
parameters ymyt ygyt jszzm jszzg jszz jssbm jssbg jssb; 
ymyt=1/(1+ygym);
ygyt=ygym/(1+ygym);

jszzm=1.56;
jssbm=3.98;

jszzg=1.56;
jssbg=4.11;

jszz=1/(am*ymyt+ag*ygyt);
jssb=1/((1-am)*ymyt+(1-ag)*ygyt);


model(linear);

////家庭 行为方程
afa1*cgt+(1-afa1)*cmt=ct;                               // 消费符合
-lt+lgl*lgt+(1-lgl)*lmt=0;                                  //劳动符合
-cgt+cmt-ru1*tot=0;                                        //消费需求                                                       
(vlabor-eta)*lt+eta*lgt-wgt+xwgt-namt=0;                     //劳动供给         
(vlabor-eta)*lt+eta*lmt-wmt+xwmt-namt=0;                      //劳动供给         
-namt=ct+0.0*(gct+(1/ru4)*(ct-gct));                          
//-namt=ct-1.0*((1/ru4)*(ct-4*gct));                         //讨论消费券时




-piet(+1)+rnt+namt(+1)-namt=0    ;           //欧拉方程    


//国有企业行为方程
(1-ag)*(1-ogm)*lgt-ygt+(1-ogm)*ag*kgt(-1)+tech_gt+ogm*jjgt=0    ;                      //产出      

-lgt+(1-afa1)*tot-(wgt*(1/(1+sbjflg))+para_gy*tax_sbt*0.2/(1+sbjflg))+ygt-xgt=0     ;                        //劳动需求 
   
  -eq18_x*piet+phig*wog*eq18_rkg*((rkg/(rkg-1))*rkgt)-ngt+eq18_x*rnt(-1)+phig*(1-wog)*ug*kgt(-1)+eq18_net*ngt(-1)+phig*(1-wog)*ug*qkgt(-1)+((1+eq18_treg*(1-ag))*tregt-eq18_treg*(1-ag)*tax_sbt)*para_gy=0 ;    //净值积累 
//  -eq18_x*piet+phig*wog*rkgt-ngt+eq18_x*rnt(-1)+phig*(1-wog)*ug*kgt(-1)+eq18_net*ngt(-1)+phig*(1-wog)*ug*qkgt(-1)+eq18_treg*tregt=0 ;    //18b

-rkgt+veig*ygt+(1-veig)*qkgt-veig*xgt-veig*kgt(-1)-qkgt(-1)=0  ;                  //资本需求

//  -piet(+1)-rkgt(+1)+rnt+ug*kgt-ug*ngt+ug*qkgt=0;                  //18c                 
-piet(+1)+rnt+ug*kgt-ug*ngt+ug*qkgt-eq18_rkg*((rkg/(rkg-1))*rkgt(+1))=0; //资本回报率  




//资本行为方程   
-kmt+ 4*delta*imt+(1-4*delta)*kmt(-1)=0   ;                            //中间品需求 非国有       
afa2*imgt+(1-afa2)*immt-imt=0    ;                              //中间品复合        非国有    
(afa2-afa1)*tot-qkmt+faig*imt-faig*kmt(-1)=0     ;              //资产价格           
-imgt+immt-ru2*tot=0    ;                                       //中间品需求          
   

-kgt+4*delta*igt+(1-4*delta)*kgt(-1)=0   ;                            //         
afa2*iggt+(1-afa2)*igmt-igt=0    ;                              //            
(afa2-afa1)*tot-qkgt+faig*igt-faig*kgt(-1)=0     ;              //           
-iggt+igmt-ru2*tot=0    ;  



//民营企业行为方程

(1-am)*(1-ogm)*lmt-ymt+am*(1-ogm)*kmt(-1)+tech_mt+ogm*jjgt=0 ;                                     //产出      
-lmt-afa1*tot-(wmt*(1/(1+sbjflm))+(1-para_gy)*tax_sbt*0.2*(1/(1+sbjflg)))+ymt=0    ;                                           //劳动需求     

 -eq28_x*piet+phim*wom*eq28_rkm*((rkm/(rkm-1)*rkmt))-nmt+eq28_x*rnt(-1)+phim*(1-wom)*um*kmt(-1)+eq28_net*nmt(-1)+phim*(1-wom)*um*qkmt(-1)+((1+eq28_trem*(1-am))*tregt-eq28_trem*(1-am)*tax_sbt)*(1-para_gy)=0   ;  //净值积累 
// -eq28_x*piet+phim*wom**rkmt-nmt+eq28_x*rnt(-1)+phim*(1-wom)*um*kmt(-1)+eq28_net*nmt(-1)+phim*(1-wom)*um*qkmt(-1)+eq28_trem*tregt=0   ;  //28b 

-rkmt+veim*ymt+(1-veim)*qkmt-veim*kmt(-1)-qkmt(-1)=0  ;               //资本需求     
        
-eq28_rkm*((rkm/(rkm-1)*rkmt(+1)))-piet(+1)+rnt+um*kmt-um*nmt+um*qkmt=0 ; //资本回报率

//政府行为方程
rpie*piet+rpieg*piegt+rpiem*piemt+rz*tot-rnt+ryg*ygt+rym*ymt+rr*rnt(-1)+rryy*yt=0    ;    

//资源约束方程
cgyg*cgt+(1/2)*(igyg*imgt+igyg*iggt)-ygt+para_gy*ggyg*govgt=0     ;                       //34            
cmym*cmt+(1/2)*(imym*immt+imym*igmt)-ymt+(1-para_gy)*gmym*govgt=0     ;                        //35 

          

  

//定义式
-piet+afa1*piegt+(1-afa1)*piemt=0  ;                                      //38            
-piegt+pgt-pgt(-1)=0      ;                                              //40              
-piemt+pmt-pmt(-1)=0     ;                                              //41               
-tot+pgt-pmt=0        ;                                                 //39               
ug*kgt-ug*ngt+ug*qkgt-riskgt=0   ;                                       //61              
um*kmt-um*nmt-riskmt+um*qkmt=0   ;                                      //62              
ygy*ygt+ymy*ymt-yt=0        ;                                          //64              
                                                     


beta*piegt(+1)-piegt-kapg*xgt=0                 ;              //19        
  

beta*wgt(+1)-wgt-kapg*xwgt=0                 ;              //50         
beta*wmt(+1)-wmt-kapg*xwmt=0               ;                   //51  


//各种冲击        
        
jjgt=0.9*jjgt(-1)+0.1*govgt;
-tech_gt+techg_ar*tech_gt(-1)+tech_gs=0;                       //4              
 -tech_mt+techm_ar*tech_mt(-1)-tech_ms=0;                      //5            
 -tregt+treg_ar*tregt(-1)+tregs=0;                             //6             
 -tremt+trem_ar*tremt(-1)+trems=0;                             //7           
-govgt+gg_ar*govgt(-1)+govgs=0;                               //8             
-gct+gm_ar*gct(-1)+gcts=0;                              //9             
-tax_sbt+0.8*tax_sbt(-1)-tax_sbs=0;
end;

resid(1);


steady;
check;

// Declaring the shocks
shocks;

var  tregs; stderr 1;                               //增值税减免
//var  tax_sbs; stderr 1;                  //社保费减免


 //var  tech_gs; stderr 1;
// var  tech_ms; stderr 1;
// var  gcts; stderr 1;
// var  trems; stderr 1;

//var  govgs; stderr 1;                              // 政府对购买的冲击
 //var  gcts; stderr 1;                              //消费券增加


 end;

// Launch solving procedure
stoch_simul(irf=35,hp_filter=1600) nmt  riskmt  kmt lmt  piemt    ct  ymt  imt ygt yt imgt   lgt  ngt riskgt tot iggt    ;     //政府对民营企业减免增值税  图3
//stoch_simul(irf=35,hp_filter=1600) nmt  riskmt imt ymt ygt yt kmt lmt  piemt    ct    imgt   lgt  ngt riskgt tot iggt    ;     //政府对民营企业减免增值税 金融加速器效应  图4
//stoch_simul(irf=60,hp_filter=1600)  ngt  riskgt  lgt kgt igt ygt     ymt yt  piemt ct imgt   kmt ct    tot  rnt;     //政府对国有企业增值税减免 图5

//社保费
 //stoch_simul(irf=30,hp_filter=1600)  tax_sbt nmt  riskmt  kmt lmt ymt    imt ygt yt  piemt ct imgt kgt    lgt  ngt riskgt tot  ;     //政府对民营企业社保费的冲击 图6
 //stoch_simul( irf=60,hp_filter=1600)  ngt kgt lgt ygt    ymt    yt  piemt ct   igt        riskgt tot tax_sbt  ;     //政府对国有企业社保费减免 图7



//政府购买
 // stoch_simul(irf=30,hp_filter=1600) ymt nmt  riskmt   imt ymt     ygt yt piemt ct  tregt   imgt kgt   kmt  ngt riskgt tot rnt ;     //政府对民营企业购买的冲击 图6
// stoch_simul( irf=30,hp_filter=1600) ygt ngt  riskgt   igt ygt     ymt yt piegt ct piemt tregt   imgt kgt   kmt     tot rnt ;     //政府对国有企业购买的冲击 图6



//各种政策比较图
//stoch_simul(irf=35,hp_filter=1600)  ygt ymt yt ct  piemt piegt piet    imt igt lgt lmt kmt kgt  rnt  ;     //政府对民营企业社保费的冲击 图5
  //  stoch_simul(irf=35,hp_filter=1600) gct  ct ymt nmt  riskmt   imt  ygt yt piet piemt piegt  ;     //消费券




